/* gm_call_i.h */

/* $Id: gm_call_i.h,v 1.1 1994/09/13 21:58:12 JACK Exp $ */

#ifndef gm_call_i_h
#define gm_call_i_h

#define GM_MAGIC              0x676d  /* flR[}WbN */

#define GM_VERSION_NUMBER     0xff80  /* flo[Wio̓ǂݎ */
#define GM_MASK_STATE         0xff81  /* }XNԂ̓ǂݎ */
#define GM_GNC_STATE          0xff82  /* fmbԂ̓ǂݎ */
#define GM_AUTO_STATE         0xff83  /* I[g}XNԂ̓ǂݎ */
#define GM_GRAPHIC_MODE_STATE 0xff84  /*OtBbN[h̓ǂݎ */
#define GM_ACTIVE_STATE       0xff85  /* flv@\̓󋵂 */

#define GM_MASK_REQUEST       0xff88  /* }XNNGXg */
#define GM_MASK_SET           0xff89  /* }XNݒ */
#define GM_MASK_CLEAR         0xff8a  /* }XN */
#define GM_AUTO_DISABLE       0xff8b  /* I[g}XN֎~ */
#define GM_AUTO_ENABLE        0xff8c  /* I[g}XN */
#define GM_ACTIVE             0xff8d  /* fl̓Jn */
#define GM_INACTIVE           0xff8e  /* fl̓~ */

#define GM_KEEP_PALETTE_GET   0xff90  /* 풓pbg(16F)̐擪AhX𓾂 */
#define GM_PALETTE_SAVE       0xff91  /* ݂̃pbgۑ */
#define GM_GVRAM_SAVE         0xff92  /* GVRAM̂݋ۑ */

#define GM_MAGIC_CHECK(n) (((n) & 0x0000ffff) == GM_MAGIC)

/* functions */

static inline int gm_version_number(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_VERSION_NUMBER))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_mask_state(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_MASK_STATE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_gnc_state(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_GNC_STATE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_auto_state(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_AUTO_STATE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_graphic_mode_state(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_GRAPHIC_MODE_STATE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_active_state(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_ACTIVE_STATE))
		 : "d1", "d2");

	return reg_d0;
}


static inline int gm_mask_request(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_MASK_REQUEST))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_mask_set(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_MASK_SET))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_mask_clear(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_MASK_CLEAR))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_auto_disable(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_AUTO_DISABLE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_auto_enable(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_AUTO_ENABLE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_active(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_ACTIVE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_inactive(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_INACTIVE))
		 : "d1", "d2");

	return reg_d0;
}


static inline int gm_keep_palette_get(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_KEEP_PALETTE_GET))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_palette_save(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_PALETTE_SAVE))
		 : "d1", "d2");

	return reg_d0;
}

static inline int gm_gvram_save(void)
{
	register unsigned int reg_d0 asm ("d0");

	asm volatile ("move.l %1,d1\n\t"
		"moveq.l #-1,d2\n\t"
		"moveq.l #__TGUSEMD,%0\n\t"
		"trap #15"
		 : "=d" (reg_d0)
		 : "n" ((int)((GM_MAGIC<<16) + GM_GVRAM_SAVE))
		 : "d1", "d2");

	return reg_d0;
}

/* variables */


#endif /* for gm_call_i_h */
